BEGIN
                FOR k IN (SELECT null FROM all_synonyms WHERE owner = 'PUBLIC' and synonym_name = 'SACCOUNT_DATA_UPDATE_V') LOOP
                                EXECUTE IMMEDIATE 'DROP PUBLIC SYNONYM SACCOUNT_DATA_UPDATE_V';
                END LOOP;
                FOR k IN (SELECT null FROM all_synonyms WHERE owner = 'PUBLIC' and synonym_name = 'SPERMISSION_DATA_UPDATE_V') LOOP
                                EXECUTE IMMEDIATE 'DROP PUBLIC SYNONYM SPERMISSION_DATA_UPDATE_V';
                END LOOP;
                FOR k IN (SELECT null FROM all_synonyms WHERE owner = 'PUBLIC' and synonym_name = 'SUSER_DATA_UPDATE_V') LOOP
                                EXECUTE IMMEDIATE 'DROP PUBLIC SYNONYM SUSER_DATA_UPDATE_V';
                END LOOP;
                FOR i IN (SELECT null FROM all_views WHERE owner = user and view_name = 'SACCOUNT_DATA_UPDATE_V') LOOP
                                EXECUTE IMMEDIATE 'DROP VIEW SACCOUNT_DATA_UPDATE_V';
                END LOOP;
                FOR i IN (SELECT null FROM all_views WHERE owner = user and view_name = 'SPERMISSION_DATA_UPDATE_V') LOOP
                                EXECUTE IMMEDIATE 'DROP VIEW SPERMISSION_DATA_UPDATE_V';
                END LOOP;
                FOR i IN (SELECT null FROM all_views WHERE owner = user and view_name = 'SUSER_DATA_UPDATE_V') LOOP
                                EXECUTE IMMEDIATE 'DROP VIEW SUSER_DATA_UPDATE_V';
                END LOOP;
END;
/

CREATE VIEW saccount_data_update_v AS 
  SELECT DISTINCT 
    sa.id AS cur_id,
    sacc.id AS col_id,
    sa.account_id AS cur_account_id,
    sacc.account_id AS col_account_id,
    sa.conn_acct_id AS cur_conn_acct_id,
    sacc.conn_acct_id AS col_conn_acct_id,
    sa.cost AS cur_cost,
    sacc.cost AS col_cost,
    sa.deleted AS cur_deleted,
    sacc.deleted AS col_deleted,
    sa.description AS cur_description,
    sacc.description AS col_description,
    sa.disabled AS cur_disabled,
    sacc.disabled AS col_disabled,
    sa.driver_id AS cur_driver_id,
    sacc.driver_id AS col_driver_id,
    sa.effective AS cur_effective,
    sacc.effective AS col_effective,
    sa.is_curated AS cur_is_curated,
    sacc.is_curated AS col_is_curated,
    sa.last_login AS cur_last_login,
    sacc.last_login AS col_last_login,
    sa.logical_id AS cur_logical_id,
    sacc.logical_id AS col_logical_id,
    sa.merged AS cur_merged,
    sacc.merged AS col_merged,
    sa.name AS cur_name,
    sacc.name AS col_name,
    sa.privileged AS cur_privileged,
    sacc.privileged AS col_privileged,
    sa.relation_to_user_type AS cur_relation_to_user_type,
    sacc.relation_to_user_type AS col_relation_to_user_type,
    sa.risk AS cur_risk,
    sacc.risk AS col_risk,
    sa.state AS cur_state,
    sacc.state AS col_state,
    sa.type AS cur_type,
    sacc.type AS col_type,
    sa.unique_account_id AS cur_unique_account_id,
    sacc.unique_account_id AS col_unique_account_id,
    sa.user_id AS cur_user_id,
    sacc.user_id AS col_user_id,
    sa.virtual AS cur_virtual,
    sacc.virtual AS col_virtual,
    sa.application AS cur_application,
    sacc.application AS col_application,
    sa.base_application AS cur_base_application,
    sacc.base_application AS col_base_application,
    sa.collected_entity AS cur_collected_entity,
    sacc.collected_entity AS col_collected_entity,
    sa.data_collection AS cur_data_collection,
    sacc.data_collection AS col_data_collection,
    sa.effective_entity AS cur_effective_entity,
    sacc.effective_entity AS col_effective_entity,
    sa.suser AS cur_suser,
    sacc.suser AS col_suser,
    sa.sversion AS cur_sversion,
    sacc.sversion AS col_sversion,
    sa.classification_id AS cur_classification_id,
    sacc.classification_id AS col_classification_id,
    sa.last_orphan_review AS cur_last_orphan_review,
    sacc.last_orphan_review AS col_last_orphan_review,
    sa.last_account_review AS cur_last_account_review,
    sacc.last_account_review AS col_last_account_review,
    sa.login_count AS cur_login_count,
    sacc.login_count AS col_login_count,
    sa.alias AS cur_alias,
    sal.alias AS col_alias,
    sa.app_name,
    ( SELECT COUNT(saccount.unique_account_id) AS count
           FROM saccount
          WHERE saccount.deleted = 0 AND saccount.is_curated = 1) AS curated,
    ( SELECT COUNT(saccount.unique_account_id) AS count
           FROM saccount
          WHERE saccount.deleted = 0 AND saccount.is_curated = 0 AND saccount.effective = 1) AS collected
   FROM ( SELECT DISTINCT saccount.id,
            saccount.account_id,
            saccount.conn_acct_id,
            saccount.cost,
            saccount.deleted,
            saccount.description,
            saccount.disabled,
            saccount.driver_id,
            saccount.effective,
            saccount.is_curated,
            saccount.last_login,
            saccount.logical_id,
            saccount.merged,
            saccount.name,
            saccount.privileged,
            saccount.relation_to_user_type,
            saccount.risk,
            saccount.state,
            saccount.type,
            saccount.unique_account_id,
            saccount.user_id,
            saccount.virtual,
            saccount.application,
            saccount.base_application,
            saccount.collected_entity,
            saccount.data_collection,
            saccount.effective_entity,
            saccount.suser,
            saccount.sversion,
            saccount.classification_id,
            saccount.last_orphan_review,
            saccount.last_account_review,
            saccount.login_count,
            ds.name AS app_name,
            sal_1.alias
           FROM saccount
             LEFT JOIN data_source ds ON saccount.application = ds.id
             LEFT JOIN saccount sac_1 ON TO_CHAR(sac_1.unique_account_id) = TO_CHAR(saccount.unique_account_id) AND sac_1.is_curated = 1
             LEFT JOIN saccount_alias sal_1 ON sal_1.saccount = sac_1.id AND NOT (TO_CHAR(sal_1.alias) IN ( SELECT sal_2.alias
                   FROM saccount sac2
                     LEFT JOIN saccount sac_2 ON sac_2.collected_entity = sac2.collected_entity AND sac_2.merged = 0
                     LEFT JOIN saccount_alias sal_2 ON sal_2.saccount = sac_2.id
                  WHERE sac2.merged = 1 AND sac2.effective = 1))
          WHERE saccount.is_curated = 1
          ORDER BY saccount.effective) sa
     LEFT JOIN saccount sac ON TO_CHAR(sac.unique_account_id) = TO_CHAR(sa.unique_account_id) AND sac.effective = 1
     LEFT JOIN saccount sacc ON sacc.collected_entity = sac.collected_entity AND sacc.effective = 0
     LEFT JOIN ( SELECT DISTINCT sac_1.id,
            sal_1.saccount,
            sal_1.alias
           FROM saccount sac2
             LEFT JOIN saccount sac_1 ON sac_1.collected_entity = sac2.collected_entity AND sac_1.merged = 0
             LEFT JOIN saccount_alias sal_1 ON sal_1.saccount = sac_1.id
          WHERE sac2.merged = 1 AND sac2.effective = 1) sal ON sal.id = sac.collected_entity 
ORDER BY sacc.name;

CREATE VIEW spermission_data_update_v AS 
  SELECT sp.id cur_id,
sper.id col_id,
MAX(ec.timestamp) cur_time,
sp.account_grant cur_account_grant,
sper.account_grant col_account_grant,
sp.assignable cur_assignable,
sper.assignable col_assignable,
sp.authoritative cur_authoritative,
sper.authoritative col_authoritative,
TO_CHAR(sp.bound_by_id) cur_bound_by_id,
TO_CHAR(sper.bound_by_id) col_bound_by_id,
sp.boundable cur_boundable,
sper.boundable col_boundable,
sp.cost cur_cost,
sper.cost col_cost,
sp.deleted cur_deleted,
sper.deleted col_deleted,
sp.description cur_description,
sper.description col_description,
sp.display_name cur_display_name,
sper.display_name col_display_name,
sp.driver_id cur_driver_id,
sper.driver_id col_driver_id,
sp.effective cur_effective,
sper.effective col_effective,
sp.exclude_from_catalog cur_exclude_from_catalog,
sper.exclude_from_catalog col_exclude_from_catalog,
sp.is_curated cur_is_curated,
sper.is_curated col_is_curated,
sp.logical_id cur_logical_id,
sper.logical_id col_logical_id,
sp.merged cur_merged,
sper.merged col_merged,
sp.name cur_name,
sper.name col_name,
sp.not_reviewable cur_not_reviewable,
sper.not_reviewable col_not_reviewable,
cur_get.cur_owner,
col_get.col_owner,
TO_CHAR(sp.permission_id) cur_permission_id,
TO_CHAR(sper.permission_id) col_permission_id,
sp.prov_attribute cur_prov_attribute,
sper.prov_attribute col_prov_attribute,
sp.prov_by_unique_permission_id cur_prov_by_unique_perm_id,
sper.prov_by_unique_permission_id col_prov_by_unique_perm_id,
sp.prov_native_value cur_prov_native_value,
sper.prov_native_value col_prov_native_value,
sp.prov_unique_driver_id cur_prov_unique_driver_id,
sper.prov_unique_driver_id col_prov_unique_driver_id,
sp.provisionable cur_provisionable,
sper.provisionable col_provisionable,
sp.risk cur_risk,
sper.risk col_risk,
sp.type cur_type,
sper.type col_type,
sp.unique_bound_by_id cur_unique_bound_by_id,
sper.unique_bound_by_id col_unique_bound_by_id,
sp.unique_permission_id cur_unique_permission_id,
sper.unique_permission_id col_unique_permission_id,
sp.value cur_value,
sper.value col_value,
sp.value_type cur_value_type,
sper.value_type col_value_type,
sp.application cur_application,
sper.application col_application,
sp.base_application cur_base_application,
sper.base_application col_base_application,
sp.collected_entity cur_collected_entity,
sper.collected_entity col_collected_entity,
sp.data_collection cur_data_collection,
sper.data_collection col_data_collection,
sp.effective_entity cur_effective_entity,
sper.effective_entity col_effective_entity,
sp.sversion cur_sversion,
sper.sversion col_sversion,
sp.auto_generated cur_auto_generated,
sper.auto_generated col_auto_generated,
sp.prov_unique_permission_id cur_prov_unique_permission_id,
sper.prov_unique_permission_id col_prov_unique_permission_id,
sp.static_permission cur_static_permission,
sper.static_permission col_static_permission,
sp.photo_uri cur_photo_uri,
sper.photo_uri col_photo_uri,
sp.photo_format cur_photo_format,
sper.photo_format col_photo_format,
sp.photo_record cur_photo_record,
sper.photo_record col_photo_record,
sp.app_name,
( SELECT count(spermission.unique_permission_id) count
  FROM spermission
  WHERE spermission.deleted = 0 AND spermission.is_curated = 1) curated,
( SELECT count(spermission.unique_permission_id) count
  FROM spermission
  WHERE spermission.deleted = 0 AND spermission.is_curated = 0 AND spermission.effective = 1) collected
FROM spermission
LEFT JOIN ( SELECT spermission.id,
  spermission.account_grant,
  spermission.assignable,
  spermission.authoritative,
  spermission.bound_by_id,
  spermission.boundable,
  spermission.cost,
  spermission.deleted,
  spermission.description,
  spermission.display_name,
  spermission.driver_id,
  spermission.effective,
  spermission.exclude_from_catalog,
  spermission.is_curated,
  spermission.logical_id,
  spermission.merged,
  spermission.name,
  spermission.not_reviewable,
  spermission.permission_id,
  spermission.prov_attribute,
  spermission.prov_by_unique_permission_id,
  spermission.prov_native_value,
  spermission.prov_unique_driver_id,
  spermission.provisionable,
  spermission.risk,
  spermission.type,
  spermission.unique_bound_by_id,
  spermission.unique_permission_id,
  spermission.value,
  spermission.value_type,
  spermission.application,
  spermission.base_application,
  spermission.collected_entity,
  spermission.data_collection,
  spermission.effective_entity,
  spermission.sversion,
  spermission.auto_generated,
  spermission.prov_unique_permission_id,
  spermission.static_permission,
  spermission.photo_uri,
  spermission.photo_format,
  spermission.photo_record,
  ds.name app_name
  FROM spermission
  LEFT JOIN data_source ds ON spermission.application = ds.id
  WHERE spermission.is_curated = 1
  ORDER BY spermission.effective) sp ON sp.id = spermission.id
LEFT JOIN spermission spe ON TO_CHAR(spe.unique_permission_id) = TO_CHAR(sp.unique_permission_id) AND spe.effective = 1
LEFT JOIN spermission sper ON sper.collected_entity = spe.collected_entity AND sper.effective = 0
LEFT JOIN entity_change ec ON TO_CHAR(ec.unique_id) = TO_CHAR(sp.unique_permission_id) AND TO_CHAR(ec.change_type) = TO_CHAR('ALTERED')
LEFT JOIN (SELECT DISTINCT sp.unique_permission_id, sp.name, LISTAGG(TO_CHAR(sus.display_name), TO_CHAR(' | ')) WITHIN GROUP (ORDER BY sus.display_name) cur_owner FROM spermission sp LEFT JOIN resolved_spermission_owner rso ON rso.permission = sp.id LEFT JOIN (SELECT UNIQUE sus.display_name, rso2.id FROM suser sus LEFT JOIN resolved_spermission_owner rso2 ON sus.unique_user_id = rso2.owner_unique_id) sus ON sus.id = rso.id WHERE sus.display_name IS NOT NULL AND sp.is_curated = 1 GROUP BY sp.name, sp.unique_permission_id) cur_get
ON cur_get.unique_permission_id = sp.unique_permission_id
LEFT JOIN (SELECT DISTINCT sp.unique_permission_id, sp.name, LISTAGG(TO_CHAR(sus.display_name), TO_CHAR(' | ')) WITHIN GROUP (ORDER BY sus.display_name) col_owner FROM spermission sp LEFT JOIN resolved_spermission_owner rso ON rso.permission = sp.collected_entity LEFT JOIN (SELECT UNIQUE sus.display_name, rso2.id FROM suser sus LEFT JOIN resolved_spermission_owner rso2 ON sus.unique_user_id = rso2.owner_unique_id) sus ON sus.id = rso.id WHERE sus.display_name IS NOT NULL AND sp.merged = 0 GROUP BY sp.name, sp.unique_permission_id) col_get 
ON col_get.unique_permission_id = spermission.unique_permission_id
LEFT JOIN entity_photo ep ON ep.id = sp.photo_record
WHERE sper.unique_permission_id IS NOT NULL
GROUP BY sp.id, 
sper.id, 
sp.account_grant, 
sper.account_grant, 
sp.assignable, 
sper.assignable, 
sp.authoritative, 
sper.authoritative, 
TO_CHAR(sp.bound_by_id), 
TO_CHAR(sper.bound_by_id), 
sp.boundable, 
sper.boundable, 
sp.cost, 
sper.cost, 
sp.deleted, 
sper.deleted, 
sp.description, 
sper.description, 
sp.display_name, 
sper.display_name, 
sp.driver_id, 
sper.driver_id, 
sp.effective, 
sper.effective, 
sp.exclude_from_catalog, 
sper.exclude_from_catalog, 
sp.is_curated, 
sper.is_curated, 
sp.logical_id, 
sper.logical_id, 
sp.merged, 
sper.merged, 
sp.name, 
sper.name, 
sp.not_reviewable, 
sper.not_reviewable, 
cur_get.cur_owner,
col_get.col_owner,
TO_CHAR(sp.permission_id), 
TO_CHAR(sper.permission_id), 
sp.prov_attribute, 
sper.prov_attribute, 
sp.prov_by_unique_permission_id, 
sper.prov_by_unique_permission_id, 
sp.prov_native_value, 
sper.prov_native_value, 
sp.prov_unique_driver_id, 
sper.prov_unique_driver_id, 
sp.provisionable, 
sper.provisionable, 
sp.risk, 
sper.risk, 
sp.type, 
sper.type, 
sp.unique_bound_by_id, 
sper.unique_bound_by_id, 
sp.unique_permission_id, 
sper.unique_permission_id, 
sp.value, 
sper.value, 
sp.value_type, 
sper.value_type, 
sp.application, 
sper.application, 
sp.base_application, 
sper.base_application, 
sp.collected_entity, 
sper.collected_entity, 
sp.data_collection, 
sper.data_collection, 
sp.effective_entity, 
sper.effective_entity, 
sp.sversion, 
sper.sversion, 
sp.auto_generated, 
sper.auto_generated, 
sp.prov_unique_permission_id, 
sper.prov_unique_permission_id, 
sp.static_permission, 
sper.static_permission, 
sp.photo_uri, 
sper.photo_uri,
sp.photo_format,
sper.photo_format,
sp.photo_record,
sper.photo_record,
sp.app_name
ORDER BY sper.name;

CREATE VIEW suser_data_update_v AS 
  SELECT DISTINCT
  su.id cur_id,
  sus.id col_id,
  MAX(ec.timestamp) cur_time,
  su.deleted cur_deleted,
  sus.deleted col_deleted,
  su.department cur_department,
  sus.department col_department,
  su.display_description cur_display_description,
  sus.display_description col_display_description,
  su.display_name cur_display_name,
  sus.display_name col_display_name,
  su.dn cur_dn,
  sus.dn col_dn,
  su.effective cur_effective,
  sus.effective col_effective,
  su.email cur_email,
  semail.email col_email,
  su.employee_status cur_employee_status,
  sus.employee_status col_employee_status,
  su.employee_type cur_employee_type,
  sus.employee_type col_employee_type,
  su.first_name cur_first_name,
  sus.first_name col_first_name,
  su.full_name cur_full_name,
  sus.full_name col_full_name,
  su.guid cur_guid,
  sus.guid col_guid,
  su.home_phone cur_home_phone,
  sus.home_phone col_home_phone,
  su.idm_dn cur_idm_dn,
  sus.idm_dn col_idm_dn,
  su.idm_tree_name cur_idm_tree_name,
  sus.idm_tree_name col_idm_tree_name,
  su.is_curated cur_is_curated,
  sus.is_curated col_is_curated,
  su.job_code cur_job_code,
  sus.job_code col_job_code,
  su.job_title cur_job_title,
  sus.job_title col_job_title,
  su.last_name cur_last_name,
  sus.last_name col_last_name,
  su.location cur_location,
  sus.location col_location,
  su.merged cur_merged,
  sus.merged col_merged,
  su.middle_name cur_middle_name,
  sus.middle_name col_middle_name,
  su.office_phone cur_office_phone,
  sus.office_phone col_office_phone,
  su.other_phone cur_other_phone,
  sus.other_phone col_other_phone,
  su.preferred_locale cur_preferred_locale,
  sus.preferred_locale col_preferred_locale,
  su.provisioning_id cur_provisioning_id,
  sus.provisioning_id col_provisioning_id,
  su.risk cur_risk,
  sus.risk col_risk,
  su.secondary_supervisor_id cur_secondary_supervisor_id,
  sus.secondary_supervisor_id col_secondary_supervisor_id,
  su.supervisor_attr_key cur_supervisor_attr,
  sus.supervisor_attr_key col_supervisor_attr,
  su.supervisor_id cur_supervisor_id,
  sus.supervisor_id col_supervisor_id,
  su.supervisor_unique_id cur_supervisor_unique_id,
  sus.supervisor_unique_id col_supervisor_unique_id,
  (SELECT soup.display_name
           FROM suser soup
          WHERE TO_CHAR(su.supervisor_unique_id) = TO_CHAR(soup.unique_user_id) AND ROWNUM <=1 AND soup.effective = 1)  cur_supervisor_name,
  ( SELECT soup.display_name
           FROM suser soup
          WHERE TO_CHAR(sus.supervisor_unique_id) = TO_CHAR(soup.unique_user_id) AND ROWNUM <=1 AND soup.effective = 1) col_supervisor_name,
  su.unique_user_id cur_unique_user_id,
  sus.unique_user_id col_unique_user_id,
  su.user_id cur_user_id,
  sus.user_id col_user_id,
  su.business_unit cur_business_unit,
  sus.business_unit col_business_unit,
  su.collected_entity cur_collected_entity,
  sus.collected_entity col_collected_entity,
  su.effective_entity cur_effective_entity,
  sus.effective_entity col_effective_entity,
  su.identity_source cur_identity_source,
  sus.identity_source col_identity_source,
  su.sversion cur_sversion,
  sus.sversion col_sversion,
  su.workforce_id cur_workforce_id,
  sus.workforce_id col_workforce_id,
  su.photo_uri cur_photo_uri,
  sus.photo_uri col_photo_uri,
  su.photo_format cur_photo_format,
  sus.photo_format col_photo_format,
  su.photo_record cur_photo_record,
  sus.photo_record col_photo_record,
  su.identity_source_name,
  su.affiliated_id cur_affiliated_id,
  sus.affiliated_id col_affiliated_id,
  (SELECT COUNT(suser.unique_user_id) count
    FROM suser
    WHERE suser.deleted = 0 AND suser.is_curated = 1) AS curated,
  (SELECT COUNT(suser.unique_user_id) AS count
    FROM suser
    WHERE suser.deleted = 0 AND suser.is_curated = 0 AND suser.effective = 1) AS collected
  FROM
    (SELECT DISTINCT suser.id,
      suser.deleted,
      suser.department,
      suser.display_description,
      suser.display_name,
      suser.dn,
      suser.effective,
      suser.employee_status,
      suser.employee_type,
      suser.first_name,
      suser.full_name,
      suser.guid,
      suser.home_phone,
      suser.idm_dn,
      suser.idm_tree_name,
      suser.is_curated,
      suser.job_code,
      suser.job_title,
      suser.last_name,
      suser.location,
      suser.merged,
      suser.middle_name,
      suser.office_phone,
      suser.other_phone,
      suser.preferred_locale,
      suser.provisioning_id,
      suser.secondary_supervisor_id,
      suser.supervisor_attr_key,
      suser.supervisor_id,
      suser.supervisor_unique_id,
      suser.unique_user_id,
      suser.user_id,
      suser.business_unit,
      suser.collected_entity,
      suser.effective_entity,
      suser.identity_source,
      suser.sversion,
      suser.workforce_id,
      suser.photo_uri,
      suser.photo_format,
      suser.photo_record,
      suser.risk,
      ds.name AS identity_source_name,
      LISTAGG((TO_CHAR(se.email)), ' | ') WITHIN GROUP (ORDER BY se.email) email,
      suser.affiliated_id
     FROM suser
       LEFT JOIN data_source ds ON suser.identity_source = ds.id
       LEFT JOIN suser_email se ON suser.id = se.suser
      WHERE suser.is_curated = 1 
      GROUP BY suser.id, suser.deleted, suser.department, suser.display_description, suser.display_name, suser.dn, suser.effective, suser.employee_status, suser.employee_type, suser.first_name, suser.full_name, suser.guid, suser.home_phone, suser.idm_dn, suser.idm_tree_name, suser.is_curated, suser.job_code, suser.job_title, suser.last_name, suser.location, suser.merged, suser.middle_name, suser.office_phone, suser.other_phone, suser.preferred_locale, suser.provisioning_id, suser.secondary_supervisor_id, suser.supervisor_attr_key, suser.supervisor_id, suser.supervisor_unique_id, suser.unique_user_id, suser.user_id, suser.business_unit, suser.collected_entity, suser.effective_entity, suser.identity_source, suser.sversion, suser.workforce_id, suser.photo_uri, suser.photo_format, suser.photo_record, suser.risk, ds.name, suser.affiliated_id
      ORDER BY suser.effective) su
  LEFT JOIN suser sus2 ON TO_CHAR(sus2.unique_user_id) = TO_CHAR(su.unique_user_id) AND sus2.effective = 1
  LEFT JOIN suser sus ON sus.collected_entity = sus2.collected_entity AND sus.effective = 0
  LEFT JOIN suser_email semail ON semail.suser = sus.id
  LEFT JOIN entity_change ec ON TO_CHAR(ec.unique_id) = TO_CHAR(su.unique_user_id) AND TO_CHAR(ec.change_type) = TO_CHAR('ALTERED')
  LEFT JOIN suser sus ON sus.collected_entity = sus2.collected_entity AND sus.effective = 0
  LEFT JOIN entity_photo ep ON ep.id = su.photo_record
  GROUP BY su.id, sus.id, su.deleted, sus.deleted, su.department, sus.department, su.display_description, sus.display_description, su.display_name, sus.display_name, su.dn, sus.dn, su.effective, sus.effective, su.email, semail.email, su.employee_status, sus.employee_status, su.employee_type, sus.employee_type, su.first_name, sus.first_name, su.full_name, sus.full_name, su.guid, sus.guid, su.home_phone, sus.home_phone, su.idm_dn, sus.idm_dn, su.idm_tree_name, sus.idm_tree_name, su.is_curated, sus.is_curated, su.job_code, sus.job_code, su.job_title, sus.job_title, su.last_name, sus.last_name, su.location, sus.location, su.merged, sus.merged, su.middle_name, sus.middle_name, su.office_phone, sus.office_phone, su.other_phone, sus.other_phone, su.preferred_locale, sus.preferred_locale, su.provisioning_id, sus.provisioning_id, su.risk, sus.risk, su.secondary_supervisor_id, sus.secondary_supervisor_id, su.supervisor_attr_key, sus.supervisor_attr_key, su.supervisor_id, sus.supervisor_id, su.supervisor_unique_id, sus.supervisor_unique_id, su.unique_user_id, sus.unique_user_id, su.user_id, sus.user_id, su.business_unit, sus.business_unit, su.collected_entity, sus.collected_entity, su.effective_entity, sus.effective_entity, su.identity_source, sus.identity_source, su.sversion, sus.sversion, su.workforce_id, sus.workforce_id, su.photo_uri, sus.photo_uri, su.photo_format, sus.photo_format, su.photo_record, sus.photo_record, su.identity_source_name, su.affiliated_id, sus.affiliated_id;

GRANT SELECT ON igops.saccount_data_update_v TO igrptuser;
CREATE OR REPLACE PUBLIC SYNONYM saccount_data_update_v for igops.saccount_data_update_v;

GRANT SELECT ON igops.spermission_data_update_v TO igrptuser;
CREATE OR REPLACE PUBLIC SYNONYM spermission_data_update_v for igops.spermission_data_update_v;

GRANT SELECT ON igops.suser_data_update_v TO igrptuser;
CREATE OR REPLACE PUBLIC SYNONYM suser_data_update_v for igops.suser_data_update_v;