DROP VIEW IF EXISTS saccount_data_update_v;
DROP VIEW IF EXISTS spermission_data_update_v;
DROP VIEW IF EXISTS suser_data_update_v;

CREATE VIEW saccount_data_update_v AS 
SELECT DISTINCT sa.id AS cur_id,
    sacc.id AS col_id,
    sa.account_id AS cur_account_id,
    sacc.account_id AS col_account_id,
    sa.conn_acct_id AS cur_conn_acct_id,
    sacc.conn_acct_id AS col_conn_acct_id,
    sa.cost AS cur_cost,
    sacc.cost AS col_cost,
    sa.deleted AS cur_deleted,
    sacc.deleted AS col_deleted,
    sa.description AS cur_description,
    sacc.description AS col_description,
    sa.disabled AS cur_disabled,
    sacc.disabled AS col_disabled,
    sa.driver_id AS cur_driver_id,
    sacc.driver_id AS col_driver_id,
    sa.effective AS cur_effective,
    sacc.effective AS col_effective,
    sa.is_curated AS cur_is_curated,
    sacc.is_curated AS col_is_curated,
    sa.last_login AS cur_last_login,
    sacc.last_login AS col_last_login,
    sa.logical_id AS cur_logical_id,
    sacc.logical_id AS col_logical_id,
    sa.merged AS cur_merged,
    sacc.merged AS col_merged,
    sa.name AS cur_name,
    sacc.name AS col_name,
    sa.privileged AS cur_privileged,
    sacc.privileged AS col_privileged,
    sa.relation_to_user_type AS cur_relation_to_user_type,
    sacc.relation_to_user_type AS col_relation_to_user_type,
    sa.risk AS cur_risk,
    sacc.risk AS col_risk,
    sa.state AS cur_state,
    sacc.state AS col_state,
    sa.type AS cur_type,
    sacc.type AS col_type,
    sa.unique_account_id AS cur_unique_account_id,
    sacc.unique_account_id AS col_unique_account_id,
    sa.user_id AS cur_user_id,
    sacc.user_id AS col_user_id,
    sa.virtual AS cur_virtual,
    sacc.virtual AS col_virtual,
    sa.application AS cur_application,
    sacc.application AS col_application,
    sa.base_application AS cur_base_application,
    sacc.base_application AS col_base_application,
    sa.collected_entity AS cur_collected_entity,
    sacc.collected_entity AS col_collected_entity,
    sa.data_collection AS cur_data_collection,
    sacc.data_collection AS col_data_collection,
    sa.effective_entity AS cur_effective_entity,
    sacc.effective_entity AS col_effective_entity,
    sa.suser AS cur_suser,
    sacc.suser AS col_suser,
    sa.sversion AS cur_sversion,
    sacc.sversion AS col_sversion,
    sa.classification_id AS cur_classification_id,
    sacc.classification_id AS col_classification_id,
    sa.last_orphan_review AS cur_last_orphan_review,
    sacc.last_orphan_review AS col_last_orphan_review,
    sa.last_account_review AS cur_last_account_review,
    sacc.last_account_review AS col_last_account_review,
    sa.login_count AS cur_login_count,
    sacc.login_count AS col_login_count,
    sa.app_name,
    ( SELECT count(saccount.unique_account_id) AS count
           FROM saccount
          WHERE saccount.deleted = false AND saccount.is_curated = true) AS curated,
    ( SELECT count(saccount.unique_account_id) AS count
           FROM saccount
          WHERE saccount.deleted = false AND saccount.is_curated = false AND saccount.effective = true) AS collected
   FROM ( SELECT DISTINCT saccount.id,
            saccount.account_id,
            saccount.conn_acct_id,
            saccount.cost,
            saccount.deleted,
            saccount.description,
            saccount.disabled,
            saccount.driver_id,
            saccount.effective,
            saccount.is_curated,
            saccount.last_login,
            saccount.logical_id,
            saccount.merged,
            saccount.name,
            saccount.privileged,
            saccount.relation_to_user_type,
            saccount.risk,
            saccount.state,
            saccount.type,
            saccount.unique_account_id,
            saccount.user_id,
            saccount.virtual,
            saccount.application,
            saccount.base_application,
            saccount.collected_entity,
            saccount.data_collection,
            saccount.effective_entity,
            saccount.suser,
            saccount.sversion,
            saccount.classification_id,
            saccount.last_orphan_review,
            saccount.last_account_review,
            saccount.login_count,
            ds.name AS app_name
           FROM saccount
             LEFT JOIN data_source ds ON saccount.application = ds.id
             LEFT JOIN saccount sac_1 ON sac_1.unique_account_id::text = saccount.unique_account_id::text AND sac_1.is_curated = true
          WHERE saccount.is_curated = true
          ORDER BY saccount.effective) sa
     LEFT JOIN saccount sac ON sac.unique_account_id::text = sa.unique_account_id::text AND sac.effective = true
     LEFT JOIN saccount sacc ON sacc.collected_entity = sac.collected_entity AND sacc.effective = false
  ORDER BY sacc.name;

CREATE VIEW spermission_data_update_v AS 
 SELECT sp.id AS cur_id,
    sper.id AS col_id,
    max(ec."timestamp") AS cur_time,
    sp.account_grant AS cur_account_grant,
    sper.account_grant AS col_account_grant,
    sp.assignable AS cur_assignable,
    sper.assignable AS col_assignable,
    sp.authoritative AS cur_authoritative,
    sper.authoritative AS col_authoritative,
    sp.bound_by_id AS cur_bound_by_id,
    sper.bound_by_id AS col_bound_by_id,
    sp.boundable AS cur_boundable,
    sper.boundable AS col_boundable,
    sp.cost AS cur_cost,
    sper.cost AS col_cost,
    sp.deleted AS cur_deleted,
    sper.deleted AS col_deleted,
    sp.description AS cur_description,
    sper.description AS col_description,
    sp.display_name AS cur_display_name,
    sper.display_name AS col_display_name,
    sp.driver_id AS cur_driver_id,
    sper.driver_id AS col_driver_id,
    sp.effective AS cur_effective,
    sper.effective AS col_effective,
    sp.exclude_from_catalog AS cur_exclude_from_catalog,
    sper.exclude_from_catalog AS col_exclude_from_catalog,
    sp.is_curated AS cur_is_curated,
    sper.is_curated AS col_is_curated,
    sp.logical_id AS cur_logical_id,
    sper.logical_id AS col_logical_id,
    sp.merged AS cur_merged,
    sper.merged AS col_merged,
    sp.name AS cur_name,
    sper.name AS col_name,
    sp.not_reviewable AS cur_not_reviewable,
    sper.not_reviewable AS col_not_reviewable,
    string_agg(DISTINCT su.display_name::text, ' | '::text) AS cur_owner,
    string_agg(DISTINCT sus.display_name::text, ' | '::text) AS col_owner,
    sp.permission_id AS cur_permission_id,
    sper.permission_id AS col_permission_id,
    sp.prov_attribute AS cur_prov_attribute,
    sper.prov_attribute AS col_prov_attribute,
    sp.prov_by_unique_permission_id AS cur_prov_by_unique_perm_id,
    sper.prov_by_unique_permission_id AS col_prov_by_unique_perm_id,
    sp.prov_native_value AS cur_prov_native_value,
    sper.prov_native_value AS col_prov_native_value,
    sp.prov_unique_driver_id AS cur_prov_unique_driver_id,
    sper.prov_unique_driver_id AS col_prov_unique_driver_id,
    sp.provisionable AS cur_provisionable,
    sper.provisionable AS col_provisionable,
    sp.risk AS cur_risk,
    sper.risk AS col_risk,
    sp.type AS cur_type,
    sper.type AS col_type,
    sp.unique_bound_by_id AS cur_unique_bound_by_id,
    sper.unique_bound_by_id AS col_unique_bound_by_id,
    sp.unique_permission_id AS cur_unique_permission_id,
    sper.unique_permission_id AS col_unique_permission_id,
    sp.value AS cur_value,
    sper.value AS col_value,
    sp.value_type AS cur_value_type,
    sper.value_type AS col_value_type,
    sp.application AS cur_application,
    sper.application AS col_application,
    sp.base_application AS cur_base_application,
    sper.base_application AS col_base_application,
    sp.collected_entity AS cur_collected_entity,
    sper.collected_entity AS col_collected_entity,
    sp.data_collection AS cur_data_collection,
    sper.data_collection AS col_data_collection,
    sp.effective_entity AS cur_effective_entity,
    sper.effective_entity AS col_effective_entity,
    sp.sversion AS cur_sversion,
    sper.sversion AS col_sversion,
    sp.auto_generated AS cur_auto_generated,
    sper.auto_generated AS col_auto_generated,
    sp.prov_unique_permission_id AS cur_prov_unique_permission_id,
    sper.prov_unique_permission_id AS col_prov_unique_permission_id,
    sp.static_permission AS cur_static_permission,
    sper.static_permission AS col_static_permission,
    sp.photo_uri AS cur_photo_uri,
    sper.photo_uri AS col_photo_uri,
    sp.photo_format AS cur_photo_format,
    sper.photo_format AS col_photo_format,
    sp.photo_record AS cur_photo_record,
    sper.photo_record AS col_photo_record,
    sp.app_name,
    ( SELECT count(spermission_1.unique_permission_id) AS count
           FROM spermission spermission_1
          WHERE spermission_1.deleted = false AND spermission_1.is_curated = true) AS curated,
    ( SELECT count(spermission_1.unique_permission_id) AS count
           FROM spermission spermission_1
          WHERE spermission_1.deleted = false AND spermission_1.is_curated = false AND spermission_1.effective = true) AS collected
   FROM spermission
     LEFT JOIN ( SELECT spermission_1.id,
            spermission_1.account_grant,
            spermission_1.assignable,
            spermission_1.authoritative,
            spermission_1.bound_by_id,
            spermission_1.boundable,
            spermission_1.cost,
            spermission_1.deleted,
            spermission_1.description,
            spermission_1.display_name,
            spermission_1.driver_id,
            spermission_1.effective,
            spermission_1.exclude_from_catalog,
            spermission_1.is_curated,
            spermission_1.logical_id,
            spermission_1.merged,
            spermission_1.name,
            spermission_1.not_reviewable,
            spermission_1.permission_id,
            spermission_1.prov_attribute,
            spermission_1.prov_by_unique_permission_id,
            spermission_1.prov_native_value,
            spermission_1.prov_unique_driver_id,
            spermission_1.provisionable,
            spermission_1.risk,
            spermission_1.type,
            spermission_1.unique_bound_by_id,
            spermission_1.unique_permission_id,
            spermission_1.value,
            spermission_1.value_type,
            spermission_1.application,
            spermission_1.base_application,
            spermission_1.collected_entity,
            spermission_1.data_collection,
            spermission_1.effective_entity,
            spermission_1.sversion,
            spermission_1.auto_generated,
            spermission_1.prov_unique_permission_id,
            spermission_1.static_permission,
            spermission_1.photo_uri,
            spermission_1.photo_format,
            spermission_1.photo_record,
            ds.name AS app_name
           FROM spermission spermission_1
             LEFT JOIN data_source ds ON spermission_1.application = ds.id
          WHERE spermission_1.is_curated = true
          ORDER BY spermission_1.effective) sp ON sp.id = spermission.id
     LEFT JOIN spermission spe ON spe.unique_permission_id::text = sp.unique_permission_id::text AND spe.effective = true
     LEFT JOIN spermission sper ON sper.collected_entity = spe.collected_entity AND sper.effective = false
     LEFT JOIN entity_change ec ON ec.unique_id::text = sp.unique_permission_id::text AND ec.change_type::text = 'ALTERED'::text
     LEFT JOIN ( SELECT DISTINCT rso.owner_unique_id,
            rso.permission AS rwo_permission_id,
            sp_1.id,
            sp_1.collected_entity
           FROM resolved_spermission_owner rso
             LEFT JOIN spermission sp_1 ON rso.permission = sp_1.id) cur_get ON cur_get.id = spermission.id
     LEFT JOIN ( SELECT DISTINCT rso.owner_unique_id,
            rso.permission AS rwo_permission_id,
            sp_1.id,
            sp_1.collected_entity
           FROM resolved_spermission_owner rso
             LEFT JOIN spermission sp_1 ON rso.permission = sp_1.collected_entity) col_get ON col_get.collected_entity = sper.id
     LEFT JOIN suser su ON su.unique_user_id::text = cur_get.owner_unique_id::text
     LEFT JOIN suser sus ON sus.unique_user_id::text = col_get.owner_unique_id::text
  WHERE sper.unique_permission_id IS NOT NULL
  GROUP BY sp.id, sper.id, sp.account_grant, sper.account_grant, sp.assignable, sper.assignable, sp.authoritative, sper.authoritative, sp.bound_by_id, sper.bound_by_id, sp.boundable, sper.boundable, sp.cost, sper.cost, sp.deleted, sper.deleted, sp.description, sper.description, sp.display_name, sper.display_name, sp.driver_id, sper.driver_id, sp.effective, sper.effective, sp.exclude_from_catalog, sper.exclude_from_catalog, sp.is_curated, sper.is_curated, sp.logical_id, sper.logical_id, sp.merged, sper.merged, sp.name, sper.name, sp.not_reviewable, sper.not_reviewable, sp.permission_id, sper.permission_id, sp.prov_attribute, sper.prov_attribute, sp.prov_by_unique_permission_id, sper.prov_by_unique_permission_id, sp.prov_native_value, sper.prov_native_value, sp.prov_unique_driver_id, sper.prov_unique_driver_id, sp.provisionable, sper.provisionable, sp.risk, sper.risk, sp.type, sper.type, sp.unique_bound_by_id, sper.unique_bound_by_id, sp.unique_permission_id, sper.unique_permission_id, sp.value, sper.value, sp.value_type, sper.value_type, sp.application, sper.application, sp.base_application, sper.base_application, sp.collected_entity, sper.collected_entity, sp.data_collection, sper.data_collection, sp.effective_entity, sper.effective_entity, sp.sversion, sper.sversion, sp.auto_generated, sper.auto_generated, sp.prov_unique_permission_id, sper.prov_unique_permission_id, sp.static_permission, sper.static_permission, sp.photo_uri, sper.photo_uri, sp.photo_format, sper.photo_format, sp.photo_record, sper.photo_record, sp.app_name
  ORDER BY sper.name;

CREATE VIEW suser_data_update_v AS 
 SELECT DISTINCT su.id AS cur_id,
    sus.id AS col_id,
    max(ec."timestamp") AS cur_time,
    su.deleted AS cur_deleted,
    sus.deleted AS col_deleted,
    su.department AS cur_department,
    sus.department AS col_department,
    su.display_description AS cur_display_description,
    sus.display_description AS col_display_description,
    su.display_name AS cur_display_name,
    sus.display_name AS col_display_name,
    su.dn AS cur_dn,
    sus.dn AS col_dn,
    su.effective AS cur_effective,
    sus.effective AS col_effective,
    su.email AS cur_email,
    semail.email AS col_email,
    su.employee_status AS cur_employee_status,
    sus.employee_status AS col_employee_status,
    su.employee_type AS cur_employee_type,
    sus.employee_type AS col_employee_type,
    su.first_name AS cur_first_name,
    sus.first_name AS col_first_name,
    su.full_name AS cur_full_name,
    sus.full_name AS col_full_name,
    su.guid AS cur_guid,
    sus.guid AS col_guid,
    su.home_phone AS cur_home_phone,
    sus.home_phone AS col_home_phone,
    su.idm_dn AS cur_idm_dn,
    sus.idm_dn AS col_idm_dn,
    su.idm_tree_name AS cur_idm_tree_name,
    sus.idm_tree_name AS col_idm_tree_name,
    su.is_curated AS cur_is_curated,
    sus.is_curated AS col_is_curated,
    su.job_code AS cur_job_code,
    sus.job_code AS col_job_code,
    su.job_title AS cur_job_title,
    sus.job_title AS col_job_title,
    su.last_name AS cur_last_name,
    sus.last_name AS col_last_name,
    su.location AS cur_location,
    sus.location AS col_location,
    su.merged AS cur_merged,
    sus.merged AS col_merged,
    su.middle_name AS cur_middle_name,
    sus.middle_name AS col_middle_name,
    su.office_phone AS cur_office_phone,
    sus.office_phone AS col_office_phone,
    su.other_phone AS cur_other_phone,
    sus.other_phone AS col_other_phone,
    su.preferred_locale AS cur_preferred_locale,
    sus.preferred_locale AS col_preferred_locale,
    su.provisioning_id AS cur_provisioning_id,
    sus.provisioning_id AS col_provisioning_id,
    su.risk AS cur_risk,
    sus.risk AS col_risk,
    su.secondary_supervisor_id AS cur_secondary_supervisor_id,
    sus.secondary_supervisor_id AS col_secondary_supervisor_id,
    su.supervisor_attr_key AS cur_supervisor_attr,
    sus.supervisor_attr_key AS col_supervisor_attr,
    su.supervisor_id AS cur_supervisor_id,
    sus.supervisor_id AS col_supervisor_id,
    su.supervisor_unique_id AS cur_supervisor_unique_id,
    sus.supervisor_unique_id AS col_supervisor_unique_id,
    ( SELECT soup.display_name
           FROM suser soup
          WHERE su.supervisor_unique_id::text = soup.unique_user_id::text
         LIMIT 1) AS cur_supervisor_name,
    ( SELECT soup.display_name
           FROM suser soup
          WHERE sus.supervisor_unique_id::text = soup.unique_user_id::text
         LIMIT 1) AS col_supervisor_name,
    su.unique_user_id AS cur_unique_user_id,
    sus.unique_user_id AS col_unique_user_id,
    su.user_id AS cur_user_id,
    sus.user_id AS col_user_id,
    su.business_unit AS cur_business_unit,
    sus.business_unit AS col_business_unit,
    su.collected_entity AS cur_collected_entity,
    sus.collected_entity AS col_collected_entity,
    su.effective_entity AS cur_effective_entity,
    sus.effective_entity AS col_effective_entity,
    su.identity_source AS cur_identity_source,
    sus.identity_source AS col_identity_source,
    su.sversion AS cur_sversion,
    sus.sversion AS col_sversion,
    su.workforce_id AS cur_workforce_id,
    sus.workforce_id AS col_workforce_id,
    su.photo_uri AS cur_photo_uri,
    sus.photo_uri AS col_photo_uri,
    su.photo_format AS cur_photo_format,
    sus.photo_format AS col_photo_format,
    su.photo_record AS cur_photo_record,
    sus.photo_record AS col_photo_record,
    su.identity_source_name,
    su.affiliated_id AS cur_affiliated_id,
    sus.affiliated_id AS col_affiliated_id,
    ( SELECT count(suser.unique_user_id) AS count
           FROM suser
          WHERE suser.deleted = false AND suser.is_curated = true) AS curated,
    ( SELECT count(suser.unique_user_id) AS count
           FROM suser
          WHERE suser.deleted = false AND suser.is_curated = false AND suser.effective = true) AS collected
   FROM ( SELECT DISTINCT suser.id,
            suser.deleted,
            suser.department,
            suser.display_description,
            suser.display_name,
            suser.dn,
            suser.effective,
            suser.employee_status,
            suser.employee_type,
            suser.first_name,
            suser.full_name,
            suser.guid,
            suser.home_phone,
            suser.idm_dn,
            suser.idm_tree_name,
            suser.is_curated,
            suser.job_code,
            suser.job_title,
            suser.last_name,
            suser.location,
            suser.merged,
            suser.middle_name,
            suser.office_phone,
            suser.other_phone,
            suser.preferred_locale,
            suser.provisioning_id,
            suser.secondary_supervisor_id,
            suser.supervisor_attr_key,
            suser.supervisor_id,
            suser.supervisor_unique_id,
            suser.unique_user_id,
            suser.user_id,
            suser.business_unit,
            suser.collected_entity,
            suser.effective_entity,
            suser.identity_source,
            suser.sversion,
            suser.workforce_id,
            suser.photo_uri,
            suser.photo_format,
            suser.photo_record,
            suser.risk,
            ds.name AS identity_source_name,
            string_agg(se.email::text, ' | '::text ORDER BY (se.email::text)) AS email,
            suser.affiliated_id
           FROM suser
             LEFT JOIN data_source ds ON suser.identity_source = ds.id
             LEFT JOIN suser_email se ON suser.id = se.suser
          WHERE suser.is_curated = true
          GROUP BY suser.id, suser.deleted, suser.department, suser.display_description, suser.display_name, suser.dn, suser.effective, suser.employee_status, suser.employee_type, suser.first_name, suser.full_name, suser.guid, suser.home_phone, suser.idm_dn, suser.idm_tree_name, suser.is_curated, suser.job_code, suser.job_title, suser.last_name, suser.location, suser.merged, suser.middle_name, suser.office_phone, suser.other_phone, suser.preferred_locale, suser.provisioning_id, suser.secondary_supervisor_id, suser.supervisor_attr_key, suser.supervisor_id, suser.supervisor_unique_id, suser.unique_user_id, suser.user_id, suser.business_unit, suser.collected_entity, suser.effective_entity, suser.identity_source, suser.sversion, suser.workforce_id, suser.photo_uri, suser.photo_format, suser.photo_record, suser.risk, ds.name, suser.affiliated_id
          ORDER BY suser.effective) su
     LEFT JOIN suser sus2 ON sus2.unique_user_id::text = su.unique_user_id::text AND sus2.effective = true
     LEFT JOIN suser sus ON sus.collected_entity = sus2.collected_entity AND sus.effective = false
     LEFT JOIN suser_email semail ON semail.suser = sus.id
     LEFT JOIN entity_change ec ON ec.unique_id::text = su.unique_user_id::text AND ec.change_type::text = 'ALTERED'::text
  GROUP BY su.id, sus.id, su.deleted, sus.deleted, su.department, sus.department, su.display_description, sus.display_description, su.display_name, sus.display_name, su.dn, sus.dn, su.effective, sus.effective, su.email, semail.email, su.employee_status, sus.employee_status, su.employee_type, sus.employee_type, su.first_name, sus.first_name, su.full_name, sus.full_name, su.guid, sus.guid, su.home_phone, sus.home_phone, su.idm_dn, sus.idm_dn, su.idm_tree_name, sus.idm_tree_name, su.is_curated, sus.is_curated, su.job_code, sus.job_code, su.job_title, sus.job_title, su.last_name, sus.last_name, su.location, sus.location, su.merged, sus.merged, su.middle_name, sus.middle_name, su.office_phone, sus.office_phone, su.other_phone, sus.other_phone, su.preferred_locale, sus.preferred_locale, su.provisioning_id, sus.provisioning_id, su.risk, sus.risk, su.secondary_supervisor_id, sus.secondary_supervisor_id, su.supervisor_attr_key, sus.supervisor_attr_key, su.supervisor_id, sus.supervisor_id, su.supervisor_unique_id, sus.supervisor_unique_id, su.unique_user_id, sus.unique_user_id, su.user_id, sus.user_id, su.business_unit, sus.business_unit, su.collected_entity, sus.collected_entity, su.effective_entity, sus.effective_entity, su.identity_source, sus.identity_source, su.sversion, sus.sversion, su.workforce_id, sus.workforce_id, su.photo_uri, sus.photo_uri, su.photo_format, sus.photo_format, su.photo_record, sus.photo_record, su.identity_source_name, su.affiliated_id, sus.affiliated_id
  ORDER BY sus.display_name;

ALTER TABLE saccount_data_update_v
  OWNER TO igops;
GRANT ALL ON TABLE saccount_data_update_v TO igops;
GRANT SELECT ON TABLE saccount_data_update_v TO ig_report_role;

ALTER TABLE spermission_data_update_v
  OWNER TO igops;
GRANT ALL ON TABLE spermission_data_update_v TO igops;
GRANT SELECT ON TABLE spermission_data_update_v TO ig_report_role;

ALTER TABLE suser_data_update_v
  OWNER TO igops;
GRANT ALL ON TABLE suser_data_update_v TO igops;
GRANT SELECT ON TABLE suser_data_update_v TO ig_report_role;